// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:msg/RobotInfo.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/msg/detail/robot_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_with_covariance__traits.hpp"
// Member 'sync'
#include "tuw_multi_robot_msgs/msg/detail/route_precondition__traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RobotInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: robot_name
  {
    out << "robot_name: ";
    rosidl_generator_traits::value_to_yaml(msg.robot_name, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: shape
  {
    out << "shape: ";
    rosidl_generator_traits::value_to_yaml(msg.shape, out);
    out << ", ";
  }

  // member: shape_variables
  {
    if (msg.shape_variables.size() == 0) {
      out << "shape_variables: []";
    } else {
      out << "shape_variables: [";
      size_t pending_items = msg.shape_variables.size();
      for (auto item : msg.shape_variables) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: sync
  {
    out << "sync: ";
    to_flow_style_yaml(msg.sync, out);
    out << ", ";
  }

  // member: mode
  {
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: good_id
  {
    out << "good_id: ";
    rosidl_generator_traits::value_to_yaml(msg.good_id, out);
    out << ", ";
  }

  // member: order_id
  {
    out << "order_id: ";
    rosidl_generator_traits::value_to_yaml(msg.order_id, out);
    out << ", ";
  }

  // member: order_status
  {
    out << "order_status: ";
    rosidl_generator_traits::value_to_yaml(msg.order_status, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RobotInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: robot_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_name: ";
    rosidl_generator_traits::value_to_yaml(msg.robot_name, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: shape
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "shape: ";
    rosidl_generator_traits::value_to_yaml(msg.shape, out);
    out << "\n";
  }

  // member: shape_variables
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.shape_variables.size() == 0) {
      out << "shape_variables: []\n";
    } else {
      out << "shape_variables:\n";
      for (auto item : msg.shape_variables) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: sync
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sync:\n";
    to_block_style_yaml(msg.sync, out, indentation + 2);
  }

  // member: mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: good_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "good_id: ";
    rosidl_generator_traits::value_to_yaml(msg.good_id, out);
    out << "\n";
  }

  // member: order_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "order_id: ";
    rosidl_generator_traits::value_to_yaml(msg.order_id, out);
    out << "\n";
  }

  // member: order_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "order_status: ";
    rosidl_generator_traits::value_to_yaml(msg.order_status, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RobotInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_multi_robot_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_multi_robot_msgs::msg::RobotInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_multi_robot_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_multi_robot_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_multi_robot_msgs::msg::RobotInfo & msg)
{
  return tuw_multi_robot_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_multi_robot_msgs::msg::RobotInfo>()
{
  return "tuw_multi_robot_msgs::msg::RobotInfo";
}

template<>
inline const char * name<tuw_multi_robot_msgs::msg::RobotInfo>()
{
  return "tuw_multi_robot_msgs/msg/RobotInfo";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::msg::RobotInfo>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::msg::RobotInfo>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::msg::RobotInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__TRAITS_HPP_
