// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:srv/StationManagerControlProtocol.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/srv/detail/station_manager_control_protocol__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const StationManagerControlProtocol_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: request
  {
    out << "request: ";
    rosidl_generator_traits::value_to_yaml(msg.request, out);
    out << ", ";
  }

  // member: addition
  {
    out << "addition: ";
    rosidl_generator_traits::value_to_yaml(msg.addition, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StationManagerControlProtocol_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "request: ";
    rosidl_generator_traits::value_to_yaml(msg.request, out);
    out << "\n";
  }

  // member: addition
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "addition: ";
    rosidl_generator_traits::value_to_yaml(msg.addition, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StationManagerControlProtocol_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_multi_robot_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_multi_robot_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_multi_robot_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request & msg)
{
  return tuw_multi_robot_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request>()
{
  return "tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request";
}

template<>
inline const char * name<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request>()
{
  return "tuw_multi_robot_msgs/srv/StationManagerControlProtocol_Request";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace tuw_multi_robot_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const StationManagerControlProtocol_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: response
  {
    out << "response: ";
    rosidl_generator_traits::value_to_yaml(msg.response, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StationManagerControlProtocol_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "response: ";
    rosidl_generator_traits::value_to_yaml(msg.response, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StationManagerControlProtocol_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_multi_robot_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_multi_robot_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_multi_robot_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response & msg)
{
  return tuw_multi_robot_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response>()
{
  return "tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response";
}

template<>
inline const char * name<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response>()
{
  return "tuw_multi_robot_msgs/srv/StationManagerControlProtocol_Response";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<tuw_multi_robot_msgs::srv::StationManagerControlProtocol>()
{
  return "tuw_multi_robot_msgs::srv::StationManagerControlProtocol";
}

template<>
inline const char * name<tuw_multi_robot_msgs::srv::StationManagerControlProtocol>()
{
  return "tuw_multi_robot_msgs/srv/StationManagerControlProtocol";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol>
  : std::integral_constant<
    bool,
    has_fixed_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request>::value &&
    has_fixed_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response>::value
  >
{
};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol>
  : std::integral_constant<
    bool,
    has_bounded_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request>::value &&
    has_bounded_size<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response>::value
  >
{
};

template<>
struct is_service<tuw_multi_robot_msgs::srv::StationManagerControlProtocol>
  : std::true_type
{
};

template<>
struct is_service_request<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request>
  : std::true_type
{
};

template<>
struct is_service_response<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__TRAITS_HPP_
