// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_multi_robot_msgs:msg/RouterStatus.idl
// generated code does not contain a copyright notice
#include "tuw_multi_robot_msgs/msg/detail/router_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `missing_robots`
#include "rosidl_runtime_c/string_functions.h"

bool
tuw_multi_robot_msgs__msg__RouterStatus__init(tuw_multi_robot_msgs__msg__RouterStatus * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // success
  // missing_robots
  if (!rosidl_runtime_c__String__Sequence__init(&msg->missing_robots, 0)) {
    tuw_multi_robot_msgs__msg__RouterStatus__fini(msg);
    return false;
  }
  // duration
  // overall_path_length
  // longest_path_length
  // priority_scheduling_attemps
  // speed_scheduling_attemps
  return true;
}

void
tuw_multi_robot_msgs__msg__RouterStatus__fini(tuw_multi_robot_msgs__msg__RouterStatus * msg)
{
  if (!msg) {
    return;
  }
  // id
  // success
  // missing_robots
  rosidl_runtime_c__String__Sequence__fini(&msg->missing_robots);
  // duration
  // overall_path_length
  // longest_path_length
  // priority_scheduling_attemps
  // speed_scheduling_attemps
}

bool
tuw_multi_robot_msgs__msg__RouterStatus__are_equal(const tuw_multi_robot_msgs__msg__RouterStatus * lhs, const tuw_multi_robot_msgs__msg__RouterStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // missing_robots
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->missing_robots), &(rhs->missing_robots)))
  {
    return false;
  }
  // duration
  if (lhs->duration != rhs->duration) {
    return false;
  }
  // overall_path_length
  if (lhs->overall_path_length != rhs->overall_path_length) {
    return false;
  }
  // longest_path_length
  if (lhs->longest_path_length != rhs->longest_path_length) {
    return false;
  }
  // priority_scheduling_attemps
  if (lhs->priority_scheduling_attemps != rhs->priority_scheduling_attemps) {
    return false;
  }
  // speed_scheduling_attemps
  if (lhs->speed_scheduling_attemps != rhs->speed_scheduling_attemps) {
    return false;
  }
  return true;
}

bool
tuw_multi_robot_msgs__msg__RouterStatus__copy(
  const tuw_multi_robot_msgs__msg__RouterStatus * input,
  tuw_multi_robot_msgs__msg__RouterStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // success
  output->success = input->success;
  // missing_robots
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->missing_robots), &(output->missing_robots)))
  {
    return false;
  }
  // duration
  output->duration = input->duration;
  // overall_path_length
  output->overall_path_length = input->overall_path_length;
  // longest_path_length
  output->longest_path_length = input->longest_path_length;
  // priority_scheduling_attemps
  output->priority_scheduling_attemps = input->priority_scheduling_attemps;
  // speed_scheduling_attemps
  output->speed_scheduling_attemps = input->speed_scheduling_attemps;
  return true;
}

tuw_multi_robot_msgs__msg__RouterStatus *
tuw_multi_robot_msgs__msg__RouterStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__RouterStatus * msg = (tuw_multi_robot_msgs__msg__RouterStatus *)allocator.allocate(sizeof(tuw_multi_robot_msgs__msg__RouterStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_multi_robot_msgs__msg__RouterStatus));
  bool success = tuw_multi_robot_msgs__msg__RouterStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_multi_robot_msgs__msg__RouterStatus__destroy(tuw_multi_robot_msgs__msg__RouterStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_multi_robot_msgs__msg__RouterStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_multi_robot_msgs__msg__RouterStatus__Sequence__init(tuw_multi_robot_msgs__msg__RouterStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__RouterStatus * data = NULL;

  if (size) {
    data = (tuw_multi_robot_msgs__msg__RouterStatus *)allocator.zero_allocate(size, sizeof(tuw_multi_robot_msgs__msg__RouterStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_multi_robot_msgs__msg__RouterStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_multi_robot_msgs__msg__RouterStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_multi_robot_msgs__msg__RouterStatus__Sequence__fini(tuw_multi_robot_msgs__msg__RouterStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_multi_robot_msgs__msg__RouterStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_multi_robot_msgs__msg__RouterStatus__Sequence *
tuw_multi_robot_msgs__msg__RouterStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__RouterStatus__Sequence * array = (tuw_multi_robot_msgs__msg__RouterStatus__Sequence *)allocator.allocate(sizeof(tuw_multi_robot_msgs__msg__RouterStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_multi_robot_msgs__msg__RouterStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_multi_robot_msgs__msg__RouterStatus__Sequence__destroy(tuw_multi_robot_msgs__msg__RouterStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_multi_robot_msgs__msg__RouterStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_multi_robot_msgs__msg__RouterStatus__Sequence__are_equal(const tuw_multi_robot_msgs__msg__RouterStatus__Sequence * lhs, const tuw_multi_robot_msgs__msg__RouterStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_multi_robot_msgs__msg__RouterStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_multi_robot_msgs__msg__RouterStatus__Sequence__copy(
  const tuw_multi_robot_msgs__msg__RouterStatus__Sequence * input,
  tuw_multi_robot_msgs__msg__RouterStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_multi_robot_msgs__msg__RouterStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_multi_robot_msgs__msg__RouterStatus * data =
      (tuw_multi_robot_msgs__msg__RouterStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_multi_robot_msgs__msg__RouterStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_multi_robot_msgs__msg__RouterStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_multi_robot_msgs__msg__RouterStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
